<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="父组织" prop="parentId">
        <el-tree-select
          v-model="formData.parentId"
          :data="organizationTree"
          :props="defaultProps"
          check-strictly
          default-expand-all
          placeholder="请选择父组织"
        />
      </el-form-item>
      <el-form-item label="组织名称" prop="name">
        <el-input v-model="formData.name" placeholder="请输入组织名称" />
      </el-form-item>
      <el-form-item label="组织等级" prop="orgClass">
        <el-radio-group v-model="formData.orgClass">
          <el-radio
            v-for="dict in getStrDictOptions(DICT_TYPE.IOT_ORG_CLASS)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="显示顺序" prop="sort">
        <el-input v-model="formData.sort" placeholder="请输入显示顺序" />
      </el-form-item>
      <el-form-item label="组织状态" prop="status">
        <el-radio-group v-model="formData.status">
          <el-radio
            v-for="dict in getIntDictOptions(DICT_TYPE.MES_MACHINE_STATUS)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="设备类型" prop="deviceType">
        <el-radio-group v-model="formData.deviceType">
          <el-radio
            v-for="dict in getStrDictOptions(DICT_TYPE.IOT_DEVICE_TYPE)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>

      <el-form-item label="机台类型" prop="machineType">
        <el-select v-model="formData.machineType" clearable placeholder="请选择机台类型">
          <el-option
            v-for="dict in getStrDictOptions(DICT_TYPE.MES_ORG_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getIntDictOptions, getStrDictOptions, DICT_TYPE } from '@/utils/dict'
import { OrganizationApi, OrganizationVO } from '@/api/iot/iotorganization'
import { defaultProps, handleTree } from '@/utils/tree'

/** IOT组织 表单 */
defineOptions({ name: 'OrganizationForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  sort: undefined,
  workerUserId: undefined,
  orgId: undefined,
  name: undefined,
  parentId: undefined,
  status: undefined,
  deviceType: undefined,
  orgClass: undefined,
  machineType: undefined,
})
const formRules = reactive({
  name: [{ required: true, message: '组织名称不能为空', trigger: 'blur' }],
  parentId: [{ required: true, message: '父组织id不能为空', trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref
const organizationTree = ref() // 树形结构

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await OrganizationApi.getOrganization(id)
    } finally {
      formLoading.value = false
    }
  }
  await getOrganizationTree()
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as OrganizationVO
    if (formType.value === 'create') {
      await OrganizationApi.createOrganization(data)
      message.success(t('common.createSuccess'))
    } else {
      await OrganizationApi.updateOrganization(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    sort: undefined,
    workerUserId: undefined,
    orgId: undefined,
    name: undefined,
    parentId: undefined,
    status: undefined,
    deviceType: undefined,
    orgClass: undefined,
    machineType: undefined,
  }
  formRef.value?.resetFields()
}

/** 获得IOT组织树 */
const getOrganizationTree = async () => {
  organizationTree.value = []
  const data = await OrganizationApi.getOrganizationList()
  const root: Tree = { id: 0, name: '顶级IOT组织', children: [] }
  root.children = handleTree(data, 'id', 'parentId')
  organizationTree.value.push(root)
}
</script>
